{$M 2048,0,655360}
uses
  TpzCRC;

const
   ZBUFSIZE = 63000;

type
   buftype = ARRAY[0..ZBUFSIZE] OF BYTE;
   String8 = String[8];

var
  InF: File;
  fbuf  : buftype;

FUNCTION Z_FileCRC32 (VAR f: FILE): LONGINT;

VAR
   crc   : LONGINT;
   n,
   bread : Word;

BEGIN
   crc := $FFFFFFFF;
   Seek(f,0);
   IF (IOresult <> 0) THEN
      {null};
   REPEAT
      BlockRead(f,fbuf,ZBUFSIZE,bread);
      FOR n := 0 TO (bread - 1) DO crc := UpdC32 (fbuf [n],crc)
   UNTIL (bread < ZBUFSIZE) OR (IOresult <> 0);
   Seek(f,0);
   IF (IOresult <> 0) THEN
      {null};
   crc := crc xor $FFFFFFFF;
   Z_FileCRC32 := crc
END;

procedure Help;
begin
  WriteLn('USAGE: MAKECRC <FILE>');
  Halt(0);
end;

function HexL(A: LongInt): String8;
type
  B4 = array [1..4] Of Byte;

var
  L: LongInt;
  B: B4 absolute L;
  S: String8;
  B1: Byte;
  i: Byte;

begin
  L := A;
  S := '';
  for i := 4 downto 1 do
  begin
    B1 := B[i];
    B1 := B1 shr 4;
    if B1 < 10 then
      S := S + Char($30+Byte(B1))
    else
      S := S + Char(65+Byte(B1 - 10));
    B1 := B[i];
    B1 := B1 and Byte($0F);
    if B1 < 10 then
      S := S + Char($30+Byte(B1))
    else
      S := S + Char(65+Byte(B1 - 10));
  end;
  HexL := S;
end;

begin
  if ParamCount <> 1 then
    Help;
  FileMode := 0;
  Assign(InF,ParamStr(1));
  {$I+} Reset(InF,1); {$I-}
  if IOResult <> 0 then
  begin
    WriteLn('Can''t open file: ',ParamStr(1));
    Halt(0);
  end;
  WriteLn('CRC32 is: ',HexL(Z_FileCRC32(InF)));
end.
